﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using TIFile;
using System.IO;

namespace TileMapToHex
{
    public partial class Form1 : Form
    {
        bool[,] SelectedTiles = new bool[12, 8];
        byte[] PictureData = new byte[768];

        public Form1()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            if (openFileDialog1.ShowDialog() != DialogResult.OK)
                return;
            pictureBox1.Image = Picture8X.ToBitmap(openFileDialog1.OpenFile(), 4);
            PictureData = Picture8X.GetData(openFileDialog1.OpenFile());
        }

        private void pictureBox1_MouseClick(object sender, MouseEventArgs e)
        {
            int X = e.X / 8 / 4;
            int Y = e.Y / 8 / 4;
            SelectedTiles[X, Y] = SelectedTiles[X, Y] ? false : true;
        }

        private void pictureBox1_Paint(object sender, PaintEventArgs e)
        {
            base.OnPaint(e);
            for (int x = 0; x < 12; x++)
                for (int y = 0; y < 8; y++)
                    if (SelectedTiles[x, y])
                        e.Graphics.FillRectangle(new SolidBrush(Color.FromArgb(155, 0, 0, 255)),
                            new Rectangle(x * 32, y * 32, 32, 32));
            pictureBox1.Invalidate();
        }

        private void button2_Click(object sender, EventArgs e)
        {
            if (string.IsNullOrEmpty(textBox1.Text))
            {
                MessageBox.Show("Please specify an on-calc name.");
                return;
            }
            if (saveFileDialog1.ShowDialog() != DialogResult.OK)
                return;
            List<byte> OutputData = new List<byte>();
            if (!checkBox1.Checked)
                OutputData.Add(0x06);
            for (int y = 0; y < 8; y++)
                for (int x = 0; x < 11; x++)
                    if (SelectedTiles[x, y])
                    {
                        // 3F = : (newline)
                        if (checkBox1.Checked)
                            OutputData.Add(0x06);
                        for (int i = 0; i < 8; i++)
                        {
                            string hex = Program8XP.ByteToHex(PictureData[((y * 8) + i) * 12 + x]);
                            OutputData.Add((byte)hex.ToCharArray()[0]);
                            OutputData.Add((byte)hex.ToCharArray()[1]);
                        }
                        if (checkBox1.Checked)
                            OutputData.Add(0x3F);
                    }
            if (!checkBox1.Checked)
                OutputData.RemoveAt(OutputData.Count - 1);
            Program8XP.Save8XP(false, OutputData.ToArray(), textBox1.Text, saveFileDialog1.FileName);
        }

        void Convert(string Picture, string OutputFile, string OnCalcName)
        {
            StreamReader reader = new StreamReader(Picture);
            Stream readStream = reader.BaseStream;
            byte[] Input = new byte[readStream.Length];
            readStream.Position = 74;
            string Output = "";
            for (int i = 1; i < 756; i++)
            {
                Output += ByteToHex((byte)readStream.ReadByte());
            }
            List<byte> buffer = new List<byte>();
            foreach (char c in Output)
            {
                buffer.Add((byte)c);
            }
            TIFile.Program8XP.Save8XP(false, buffer.ToArray(), OnCalcName, OutputFile);
            reader.Close();
        }

        public string ConvertToHex(byte[] Input)
        {
            string hex = "";
            foreach (byte c in Input)
                hex += ByteToHex(c);
            return hex;
        }

        public string ByteToHex(byte Byte)
        {
            int first = (int)Byte / 16;
            int second = (int)Byte % 16;
            return "0123456789ABCDEF".Substring(first, 1) +
                "0123456789ABCDEF".Substring(second, 1);
        }
    }
}
